<template>
  <v-row justify="center" no-gutters>
    <v-col cols="12" align="center">
      <v-data-table
        :headers="itemHeaders"
        :items="itemProducts"
        :single-expand="true"
        item-key="id"
        show-expand
        class="elevation-0"
        disable-filtering
        disable-pagination
        hide-default-footer
      >
        <template #expanded-item="{ headers, item }">
          <td :colspan="headers.length">
            <items-per-product
              :items="itemByProductId(item.detailsId)"
            />
          </td>
        </template>

        <template #item.count="{ item }">
          {{ countProductItems(item.detailsId) }}
        </template>
      </v-data-table>
      <v-btn
        :loading="loading"
        color="primary"
        class="ma-7"
        depressed
        :disabled="allStored"
        @click="confirmStorage"
      >
        Confirmar Almacenamiento
      </v-btn>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { __, indexBy, keys, map, prop } from 'ramda';
import { hashId } from '~/helpers/format/ids';
import ItemsPerProduct from '~/components/Storage/Shipments/Details/Extra/CommodityItems/ItemsPerProduct';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'ItemsPerZone',
  components: {
    ItemsPerProduct,
  },
  props: {
    items: {
      type: Object,
      default: () => ({}),
    },
    zoneId: {
      type: [String, Number],
      required: true,
    },
    orderIds: {
      type: Array,
      default: () => [],
    },
    allStored: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      loading: false,
      itemHeaders: [
        { text: 'Nª', align: 'start', value: 'detailsId' },
        { text: 'Producto a almacenar', value: 'description' },
        { text: 'Unidades (pallets)', align: 'center', value: 'count' },
      ],
    };
  },
  computed: {
    shipmentId() {
      return this.$route.params.id;
    },
    centerId() {
      return this.$auth.user.center.id;
    },
    ...mapState({
      products: state => state.storage.shipments.current.products,
    }),
    itemProducts() {
      const prods = indexBy(prop('detailsId'), this.products);
      return map(prop(__, prods), keys(this.items));
    },
  },
  methods: {
    hashId,
    ...mapActions({
      getShipment: 'storage/shipments/getShipmentDetails',
      confirmItemsStorage: 'storage/shipments/confirmItemsStorage',
    }),
    itemByProductId(detailsId) {
      return prop(detailsId, this.items);
    },
    countProductItems(detailsId) {
      return prop(detailsId, this.items)?.length ?? 0;
    },
    async confirmStorage() {
      try {
        this.loading = true;
        await this.confirmItemsStorage({
          orderIds: this.orderIds,
          zoneId: this.zoneId,
          shipmentId: this.shipmentId,
          centerId: this.centerId,
        });
        await this.getShipment({ shipmentId: this.shipmentId });
        this.$toast.success('Se ha confirmado el almacenamiento correctamente', successOptions);
      } catch (e) {
        this.$toast.error('No se ha podido confirmar el almacenamiento', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
